----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 12/07/2017 08:29:36 PM
-- Design Name: 
-- Module Name: Binary_to_integar - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

--Uncomment the following library declaration if using
--arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
library UNISIM;
use UNISIM.VComponents.all;


entity inverse_matrix_1 is
    Port ( A : in STD_LOGIC_VECTOR (3 downto 0);
           B : in STD_LOGIC_VECTOR (3 downto 0);
           C : in STD_LOGIC_VECTOR (3 downto 0);
           D: in STD_LOGIC_VECTOR (3 downto 0);
           E : out STD_LOGIC_VECTOR (7 downto 0);
           F : out STD_LOGIC_VECTOR (7 downto 0);
           G : out STD_LOGIC_VECTOR (7 downto 0);
           H : out STD_LOGIC_VECTOR (7 downto 0));
end inverse_matrix_1;






architecture Behavioral of inverse_matrix_1 is

signal A1 : integer := 0;
signal B1 : integer := 0;
signal C1 : integer := 0;
signal D1 : integer := 0;
signal E1 : integer := 0;
signal F1 : integer := 0;
signal G1 : integer := 0;
signal H1 : integer := 0;
signal Z1 : integer := (-1);
signal det : integer := 0;
signal rdet : integer := 0;
signal W1 : integer := 1;


function  divide  (a : UNSIGNED; b : UNSIGNED) return integer is
variable a1 : unsigned(a'length-1 downto 0):=a;
variable b1 : unsigned(b'length-1 downto 0):=b;
variable p1 : unsigned(b'length downto 0):= (others => '0');
variable i : integer:=0;

begin
for i in 0 to b'length-1 loop
p1(b'length-1 downto 1) := p1(b'length-2 downto 0);
p1(0) := a1(a'length-1);
a1(a'length-1 downto 1) := a1(a'length-2 downto 0);
p1 := p1-b1;
if(p1(b'length-1) ='1') then
a1(0) :='0';
p1 := p1+b1;
else
a1(0) :='1';
end if;
end loop;
return to_integer(unsigned(a1));


end divide;


begin
--H <= A;
--E <= D;




A1 <= to_integer(unsigned(A));
B1 <= to_integer(unsigned(B));
C1 <= to_integer(unsigned(C));
D1 <= to_integer(unsigned(D));
--F <= std_logic_vector(to_unsigned(F1, 4));
--C1 <= C1 * F1;
--F <= std_logic_vector(to_unsigned(F1, 4));
det <= ((A1*D1) - (C1*B1));
rdet <= divide(to_unsigned(W1, 7), to_unsigned(det, 7));
H1 <= A1 * rdet;
E1 <= D1 * rdet;
F1 <= B1 * rdet * Z1;
G1 <= C1 * rdet * Z1;
E <= std_logic_vector(to_unsigned(E1, 8));
F <= std_logic_vector(to_unsigned(F1, 8));
G <= std_logic_vector(to_unsigned(G1, 8));
H <= std_logic_vector(to_unsigned(H1, 8));




end Behavioral;
