----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 11/27/2017 03:10:09 PM
-- Design Name: 
-- Module Name: SerialControl - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
--use IEEE.STD_LOGIC_ARITH.ALL;
--use IEEE.STD_LOGIC_UNSIGNED.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity SerialControl is
    Port ( RXD : in STD_LOGIC;
           TXD : out STD_LOGIC;
           TXD_DEBUG : out STD_LOGIC;
           CLK : in STD_LOGIC;
           btnC : in STD_LOGIC;
           sw : in STD_LOGIC_VECTOR (15 downto 0));
end SerialControl;

architecture Behavioral of SerialControl is

component UART is
Port ( 
		TXD 	: out std_logic  	:= '1';
    	RXD 	: in  std_logic;					
    	CLK 	: in  std_logic;								--Master Clock = 50MHz
		DBIN 	: in  std_logic_vector (7 downto 0);	--Data Bus in
		DBOUT : out std_logic_vector (7 downto 0);	--Data Bus out
		RDA	: inout std_logic;						   --Read Data Available
		TBE	: inout std_logic 	:= '1';			   --Transfer Bus Empty
		RD		: in  std_logic;					         --Read Strobe
		WR		: in  std_logic;					         --Write Strobe
		PE		: out std_logic;					         --Parity Error Flag
		FE		: out std_logic;					         --Frame Error Flag
		OE		: out std_logic;					         --Overwrite Error Flag
		RST		: in  std_logic	:= '0');	         --Master Reset
end component;

signal data : STD_LOGIC_VECTOR(7 downto 0);
signal TXD_SIG : STD_LOGIC;
signal pulse : STD_LOGIC;

begin 

UART1 : UART
Port Map(
    TXD => TXD_SIG,
    RXD => RXD,
    CLK => CLK,
    DBIN => data,
    RD => '0',
    WR => btnC);
 
with sw select
data <= "01000001" when "0000000000000001", --A
        "01000010" when "0000000000000010", --B
        "01000011" when "0000000000000011", --C
        "01000100" when "0000000000000100", --D
        "01000101" when "0000000000000101", --E
        "01000110" when "0000000000000110", --F
        "00000000" when others;
        
process (CLK)
begin


TXD <= TXD_SIG;
TXD_DEBUG <= TXD_SIG;

end Behavioral;
