----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 12/07/2017 11:46:11 PM
-- Design Name: 
-- Module Name: solver_complete - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity solver_complete is
    Port ( A : in STD_LOGIC_VECTOR (3 downto 0);
           B : in STD_LOGIC_VECTOR (3 downto 0);
           C : in STD_LOGIC_VECTOR (3 downto 0);
           D : in STD_LOGIC_VECTOR (3 downto 0);
           X : in STD_LOGIC_VECTOR (7 downto 0);
           Y : in STD_LOGIC_VECTOR (7 downto 0);
           U : out STD_LOGIC_VECTOR (7 downto 0);
           V : out STD_LOGIC_VECTOR (7 downto 0)
           ); 
end solver_complete;

architecture Behavioral of solver_complete is

component inverse_matrix_1 is
    Port ( A : in STD_LOGIC_VECTOR (3 downto 0);
           B : in STD_LOGIC_VECTOR (3 downto 0);
           C : in STD_LOGIC_VECTOR (3 downto 0);
           D : in STD_LOGIC_VECTOR (3 downto 0);
           E : out STD_LOGIC_VECTOR (7 downto 0);
           F : out STD_LOGIC_VECTOR (7 downto 0);
           G : out STD_LOGIC_VECTOR (7 downto 0);
           H : out STD_LOGIC_VECTOR (7 downto 0));
end component;

component multiplier is
    Port ( E : in STD_LOGIC_VECTOR (7 downto 0);
           F : in STD_LOGIC_VECTOR (7 downto 0);
           G : in STD_LOGIC_VECTOR (7 downto 0);
           H : in STD_LOGIC_VECTOR (7 downto 0);
           X : in STD_LOGIC_VECTOR (7 downto 0);
           Y : in STD_LOGIC_VECTOR (7 downto 0);
           U : out STD_LOGIC_VECTOR (7 downto 0);
           V : out STD_LOGIC_VECTOR (7 downto 0));
end component;

signal E, F, G, H : STD_LOGIC_VECTOR(7 downto 0);

begin


I1 : inverse_matrix_1
Port Map(
    A => A,
    B => B,
    C => C,
    D => D,
    E => E,
    F => F,
    G => G,
    H => H);
    
M1 : multiplier
Port Map(
    E => E,
    F => F,
    G => G,
    H => H,
    X => X,
    Y => Y,
    U => U,
    V => V
    );

end Behavioral;
